diff --git a/Rakefile b/Rakefile
index 9f5959cd8..70d02d824 100644
--- a/Rakefile
+++ b/Rakefile
@@ -45,4 +45,21 @@ task :e2e do
   ruby "bin/hive-e2e", "run"
 end
 
+namespace :release do
+  desc "Build the vendored-Ruby hive binary for this OS/arch (U1, via Tebako)"
+  task :build do
+    ruby "tools/tebako/build.rb"
+  end
+
+  desc "Print the release asset bytes / SHA-256 for the local build"
+  task :checksum do
+    require "digest"
+    dist = File.expand_path("dist", __dir__)
+    path = File.join(dist, "hive")
+    abort "no #{path}; run `rake release:build` first" unless File.exist?(path)
+    puts "#{Digest::SHA256.file(path).hexdigest}  hive"
+  end
+end
+
+
 task default: :test
diff --git a/hive.gemspec b/hive.gemspec
new file mode 100644
index 000000000..1875767c6
--- /dev/null
+++ b/hive.gemspec
@@ -0,0 +1,38 @@
+# frozen_string_literal: true
+
+require_relative "lib/hive" unless defined?(Hive::VERSION)
+
+Gem::Specification.new do |spec|
+  spec.name = "hive"
+  spec.version = Hive::VERSION
+  spec.authors = [ "Ivan Kuznetsov" ]
+  spec.summary = "Agent-driven workflow orchestration (daemon + CLI + TUI)"
+  spec.homepage = "https://github.com/ivankuznetsov/hive"
+  spec.license = "MIT"
+
+  spec.required_ruby_version = "~> 3.4"
+
+  # U1: the gem surface is the same set the Tebako release build ships into
+  # the vendored binary. Keeping `files` explicit here (rather than letting
+  # the sdist glob everything under lib/) matters because the two FFI gems
+  # (bubbletea/lipgloss) bind native Go libs that must be vendored separately.
+  spec.files = Dir[
+    "bin/*",
+    "lib/**/*.rb",
+    "lib/**/*.sh",
+    "templates/**/*",
+    "schemas/**/*",
+    "examples/**/*"
+  ]
+  spec.bindir = "bin"
+  spec.executables = %w[hive]
+  spec.require_paths = [ "lib" ]
+  spec.extra_rdoc_files = %w[README.md CHANGELOG.md]
+
+  # Runtime dependencies (the vendored binary bundles these so no system
+  # gems are needed at runtime; they drive `bundle install` for the build).
+  spec.add_dependency "thor", "~> 1.3"
+  spec.add_dependency "telegram-bot-ruby", "~> 2.7"
+  spec.add_dependency "bubbletea", "= 0.1.4"
+  spec.add_dependency "lipgloss", "~> 0.2.2"
+end
\ No newline at end of file
diff --git a/lib/hive.rb b/lib/hive.rb
index 8db3300ab..a2d5f10ce 100644
--- a/lib/hive.rb
+++ b/lib/hive.rb
@@ -39,8 +39,15 @@ module Hive
     # draft-2020-12 validator. Pass an explicit `version:` to load an
     # older revision (e.g. for back-compat tests against pinned
     # consumers).
+    #
+    # Install-aware (U2): a packaged binary has no source tree, so the
+    # schema files are shipped into the XDG data dir. Resolution is
+    # data-dir-first (~/.local/share/hive/schemas/) with a source-tree
+    # fallback for `git clone` / dev usage.
     def self.schema_dir
-      File.expand_path("../schemas", __dir__)
+      require "hive/paths"
+      installed = Hive::Paths.schemas_dir
+      File.directory?(installed) ? installed : File.expand_path("../schemas", __dir__)
     end
 
     def self.schema_path(name, version: nil)
@@ -366,6 +373,15 @@ module Hive
   class TmuxError < AgentError
   end
 
+  # Raised by `hive update` when the install channel's native updater exits
+  # non-zero (brew upgrade / AUR helper / curl | bash). Maps to SOFTWARE (70)
+  # per the documented exit-code contract, not the generic 1.
+  class UpdaterError < Error
+    def exit_code
+      ExitCodes::SOFTWARE
+    end
+  end
+
   class ConfigError < Error
     def exit_code
       ExitCodes::CONFIG
diff --git a/lib/hive/cli.rb b/lib/hive/cli.rb
index 9bc60cb8c..a8db2eb28 100644
--- a/lib/hive/cli.rb
+++ b/lib/hive/cli.rb
@@ -25,6 +25,44 @@ module Hive
     end
     map "--version" => :version
 
+    desc "update", "Update hive via the detected channel's native updater"
+    long_desc <<~DESC
+      Shelves out to the channel that installed hive (recorded in
+      ~/.local/state/hive/install-method): `brew upgrade <tap>/hive/hive`,
+      the AUR helper (default `yay -Syu hive-bin`), or re-running the
+      `curl | bash` one-liner. Never downloads/overwrites the binary itself
+      (R14) — a package-managed install stays fully managed.
+
+      Exit codes: 0 success; 1 unknown/absent install-channel marker
+      (never guesses); 70 on updater failure.
+    DESC
+    def update
+      require "hive/commands/update"
+      Hive::Commands::Update.new.call
+    end
+
+    desc "uninstall", "Remove hive's binary registration + daemon unit (skills untouched)"
+    long_desc <<~DESC
+      Removes hive-owned artifacts: the installed binary and the daemon OS
+      unit, and clears the install-method marker. A brew/AUR-managed binary
+      is handed off to the package manager's uninstaller (never deleted in
+      place). NEVER deletes user work or project `.hive-state/` dirs by
+      default, and agent skills are removed only via each agent's
+      marketplace (R15).
+
+      --purge additionally removes XDG config/data/cache dirs, but ALWAYS
+      preserves ~/.local/state/hive and project `.hive-state/` (completed-
+      work artifacts survive even a purge).
+
+      Exit codes: 0 success; 64 invalid flags; 70 internal error.
+    DESC
+    option :purge, type: :boolean, default: false,
+                   desc: "also remove XDG config/data/cache (never state/ work)"
+    def uninstall
+      require "hive/commands/uninstall"
+      Hive::Commands::Uninstall.new(purge: options[:purge], json: options[:json]).call
+    end
+
     desc "init [PROJECT_PATH]", "Bootstrap .hive-state (orphan hive/state branch); TTY-prompts for agents + limits"
     long_desc <<~DESC
       Initialises hive in PROJECT_PATH (defaults to the current directory):
@@ -70,7 +108,8 @@ module Hive
 
     desc "forget NAME", "Remove a project from the global registry (inverse of `hive init`)"
     long_desc <<~DESC
-      Drops the entry whose `name` matches NAME from ~/Dev/hive/config.yml.
+      Drops the entry whose `name` matches NAME from the global config
+      (~/.config/hive/config.yml).
       The project's .hive-state directory on disk (if any) is left alone.
 
       An unknown name is a USAGE error (64), mirroring `hive metrics
@@ -94,7 +133,8 @@ module Hive
 
     desc "prune", "Drop registry entries whose project path no longer exists"
     long_desc <<~DESC
-      Walks ~/Dev/hive/config.yml and removes every `registered_projects`
+      Walks the global config (~/.config/hive/config.yml) and removes every
+      `registered_projects`
       entry whose `path` is not a directory on disk OR whose row shape is
       invalid (non-Hash, missing `path`, etc. — hand-edit accidents).
       Useful after running `hive init` against `mktemp -d` directories
@@ -595,7 +635,7 @@ module Hive
                                           --json emits hive-bot-reload.v1.
         tail                              Stream bot.log.
 
-      The bot reads the global `bot:` block from ~/Dev/hive/config.yml.
+      The bot reads the global `bot:` block from ~/.config/hive/config.yml.
       Its Telegram token comes only from HIVE_TELEGRAM_BOT_TOKEN. Incoming
       updates from chat IDs outside bot.chat_id_allowlist are ignored.
 
diff --git a/lib/hive/commands/forget.rb b/lib/hive/commands/forget.rb
index d2fbd014b..28aafda62 100644
--- a/lib/hive/commands/forget.rb
+++ b/lib/hive/commands/forget.rb
@@ -4,7 +4,7 @@ require "hive/config"
 module Hive
   module Commands
     # `hive forget NAME [--json]` — remove the entry whose `name` matches
-    # NAME from the global registry (~/Dev/hive/config.yml). The
+    # NAME from the global registry (~/.config/hive/config.yml). The
     # project's `.hive-state` directory on disk is not touched; the
     # registry and the on-disk state are independent.
     #
diff --git a/lib/hive/commands/init.rb b/lib/hive/commands/init.rb
index b86e8d610..d2508e3ba 100644
--- a/lib/hive/commands/init.rb
+++ b/lib/hive/commands/init.rb
@@ -3,13 +3,14 @@ require "fileutils"
 require "stringio"
 require "hive/config"
 require "hive/git_ops"
+require "hive/service"
 require "hive/commands/init/prompts"
 require "hive/commands/doctor"
 
 module Hive
   module Commands
     class Init
-      def initialize(project_path, force: false, prompts: nil)
+      def initialize(project_path, force: false, prompts: nil, service: nil)
         @project_path = File.expand_path(project_path)
         @force = force
         # Optional Prompts instance for testability. Tests inject a
@@ -19,6 +20,10 @@ module Hive
         # summary_io: $stdout)` runs (UI on stderr, machine-parseable
         # summary on stdout — see #collect_prompt_answers below).
         @prompts = prompts
+        # Optional Service module for testability (U3). Tests inject a
+        # stub (or set home_override) so unit files are written under a
+        # temp HOME instead of the real one. Defaults to Hive::Service.
+        @service = service || Hive::Service
       end
 
       def call
@@ -44,6 +49,8 @@ module Hive
 
         entry = Hive::Config.register_project(name: File.basename(@project_path), path: @project_path)
 
+        register_daemon_service(answers: answers)
+
         print_summary(entry: entry, ops: ops)
         run_init_preflight!
       end
@@ -103,6 +110,55 @@ module Hive
         nil
       end
 
+      # U3: after registration, persist the collected first-run provider/model
+      # into the global config (~/.config/hive/config.yml) and register the
+      # daemon as an OS-level service unit (launchd / systemd-user), prompting
+      # before enabling + starting it (never silent autostart).
+      def register_daemon_service(answers:)
+        write_first_run_config(answers)
+        register_os_service_unit
+      end
+
+      # Write the first-run provider/model (R13) into the global config. The
+      # default provider ("default") with no model is a no-op so an automated
+      # non-interactive init does not fabricate a provider the operator never
+      # chose.
+      def write_first_run_config(answers)
+        default_provider = Hive::Commands::Init::Prompts::DEFAULT_PROVIDER
+        provider = answers["provider"]
+        model = answers["model"]
+        return if (provider.nil? || provider == default_provider) && model.nil?
+
+        Hive::Config.upsert_first_run!(provider: provider, model: model)
+      end
+
+      # Generate the daemon OS unit, then — only behind an explicit prompt —
+      # run the enable + start commands. The unit is written regardless so the
+      # operator can enable/start it later; nothing autostarts silently.
+      def register_os_service_unit
+        @service.generate
+        return unless autostart_confirmed?
+
+        run_enable_start_commands!
+      end
+
+      # The autostart question is asked on the real operator terminal, NOT on
+      # an injected @prompts instance (those are test-only and their fed input
+      # stream is fully consumed by collect). A fresh Prompts bound to $stdin
+      # both matches production (non-TTY → default no) and keeps injected-
+      # prompts tests free of an extra autostart input line.
+      def autostart_confirmed?
+        Hive::Commands::Init::Prompts.new(
+          input: $stdin, output: $stderr, summary_io: $stdout
+        ).autostart?
+      end
+
+      def run_enable_start_commands!
+        @service.enable_start_commands.each do |cmd|
+          system(cmd)
+        end
+      end
+
       def print_summary(entry:, ops:)
         c = Palette.for($stdout)
         name = entry["name"]
diff --git a/lib/hive/commands/init/prompts.rb b/lib/hive/commands/init/prompts.rb
index 088635f9c..0c5f5a477 100644
--- a/lib/hive/commands/init/prompts.rb
+++ b/lib/hive/commands/init/prompts.rb
@@ -28,6 +28,13 @@ module Hive
         DEFAULT_TRIAGE_BIAS = "courageous".freeze
         TRIAGE_BIASES = %w[courageous safetyist].freeze
 
+        # U3 first-run provider/model defaults. hive routes work through
+        # per-CLI agent profiles (claude/codex/pi), so a "default" provider
+        # means "let each profile decide" and a nil model means "auto /
+        # unspecified". These land in ~/.config/hive/config.yml (`first_run`),
+        # never in a project's .hive-state config.
+        DEFAULT_PROVIDER = "default".freeze
+
         # Reviewer entries shipped in templates/project_config.yml.erb. The
         # multi-select prompt offers these as the toggleable set; rendering
         # honours the user's subset. The order is the stable iteration
@@ -109,6 +116,8 @@ module Hive
           triage_bias = prompt_triage_bias
           budgets, timeouts = prompt_limits
           daemon_enabled = prompt_daemon_enabled
+          provider = prompt_provider
+          model = prompt_model
 
           answers = {
             "planning_agent" => planning,
@@ -117,7 +126,9 @@ module Hive
             "triage_bias" => triage_bias,
             "budgets" => budgets,
             "timeouts" => timeouts,
-            "daemon_enabled" => daemon_enabled
+            "daemon_enabled" => daemon_enabled,
+            "provider" => provider,
+            "model" => model
           }
 
           summarize(answers)
@@ -125,6 +136,28 @@ module Hive
           answers
         end
 
+        # U3 autostart prompt — separate from the per-project daemon
+        # enrollment prompt (which controls whether the daemon auto-advances a
+        # *project*). This controls whether init ENABLES + STARTS the OS-level
+        # daemon service unit (launchd / systemd-user). Defaults to no action
+        # (never silent autostart); non-TTY (CI) returns false without asking.
+        def autostart?
+          return false unless interactive?
+
+          @output.puts ""
+          @output.puts "Register + start the hive daemon with your OS service manager"
+          @output.puts "(launchd on macOS / systemd-user on Linux)?"
+          loop do
+            @output.print "Enable + start the daemon now? [y/N]: "
+            @output.flush
+            answer = read_line.downcase
+            return false if answer.empty? || answer == "n" || answer == "no"
+            return true  if answer == "y" || answer == "yes"
+
+            @output.puts "  please answer y or n"
+          end
+        end
+
         # Whether prompts will fire. Public so the caller can pre-flight-
         # check before opening the prompt; also matches the test contract
         # in plan U3 (R9 testability — agents not yet installed on the
@@ -143,7 +176,11 @@ module Hive
             "triage_bias" => DEFAULT_TRIAGE_BIAS,
             "budgets" => default_budgets,
             "timeouts" => default_timeouts,
-            "daemon_enabled" => true
+            "daemon_enabled" => true,
+            # Non-TTY: no first-run provider/model is collected (no guessing);
+            # DEFAULT_PROVIDER is still returned so callers see a stable value.
+            "provider" => DEFAULT_PROVIDER,
+            "model" => nil
           }
           # Goes to @summary_io (stdout by default) so a non-TTY caller's
           # `summary=$(hive init)` capture has a parseable single line.
@@ -332,6 +369,23 @@ module Hive
           v.positive? ? v : nil
         end
 
+        def prompt_provider
+          @output.puts ""
+          @output.puts "First-run LLM provider/model (stored in ~/.config/hive/config.yml,"
+          @output.puts "not in this project's config). Blank provider = default."
+          @output.print "Default LLM provider [#{DEFAULT_PROVIDER}]: "
+          @output.flush
+          answer = read_line
+          answer.empty? ? DEFAULT_PROVIDER : answer
+        end
+
+        def prompt_model
+          @output.print "Default model (blank = auto/unspecified): "
+          @output.flush
+          answer = read_line
+          answer.empty? ? nil : answer
+        end
+
         def prompt_daemon_enabled
           @output.puts ""
           @output.puts "Hive daemon — auto-advance tasks through the pipeline."
@@ -361,6 +415,9 @@ module Hive
           @output.puts "  triage_bias       = #{answers['triage_bias']}"
           @output.puts "  limits            = #{summarize_limits(answers)}"
           @output.puts "  daemon            = #{answers['daemon_enabled'] ? 'enabled' : 'disabled'}"
+          if answers['provider'] || answers['model']
+            @output.puts "  provider/model    = #{answers['provider'].inspect}/#{answers['model'].inspect}"
+          end
         end
 
         def summarize_limits(answers)
diff --git a/lib/hive/commands/prune.rb b/lib/hive/commands/prune.rb
index c91f02d7b..e1bdfac6b 100644
--- a/lib/hive/commands/prune.rb
+++ b/lib/hive/commands/prune.rb
@@ -4,7 +4,7 @@ require "hive/config"
 module Hive
   module Commands
     # `hive prune [--dry-run] [--json]` — drop every registry entry in
-    # ~/Dev/hive/config.yml whose `path` no longer points at a directory.
+    # the global config (~/.config/hive/config.yml) whose `path` no longer points at a directory.
     # Also drops malformed entries (non-Hash rows, rows missing `path`,
     # rows whose `path` isn't a String) — these are hand-edit accidents
     # and have always been undisplayable in `hive status`. The
diff --git a/lib/hive/commands/uninstall.rb b/lib/hive/commands/uninstall.rb
new file mode 100644
index 000000000..3bfa2c173
--- /dev/null
+++ b/lib/hive/commands/uninstall.rb
@@ -0,0 +1,129 @@
+require "json"
+require "fileutils"
+require "hive"
+require "hive/paths"
+require "hive/install_method"
+require "hive/service"
+
+module Hive
+  module Commands
+    # `hive uninstall` (R15 / U5). Removes the binary registration and the
+    # daemon OS unit, and (only behind an explicit opt-in) cleans XDG
+    # dirs. It never deletes user work or accumulated pipeline state by
+    # default, and never touches agent skills (those are removed only via
+    # the agent marketplace, R15).
+    #
+    #   default:  remove binary + daemon unit (+ install-method marker);
+    #             prompt before removing project `.hive-state/` dirs; keep
+    #             XDG config/data/cache/state untouched.
+    #   --purge:  also remove XDG config/data/cache (registrations +
+    #             installed assets) but ALWAYS preserve XDG state dir
+    #             (~/.local/state/hive) and project `.hive-state/` dirs —
+    #             completed-work artifacts survive even a purge.
+    #
+    # A brew/aur-managed binary is handed off to the package manager's
+    # own uninstaller (never deleted in place); the bash one-liner binary
+    # (~/.local/bin/hive|hv) is deleted directly.
+    class Uninstall
+      def initialize(purge: false, json: false, runner: method(:system), service: Hive::Service)
+        @purge = purge
+        @json = json
+        @runner = runner
+        @service = service
+        @removed = []
+        @kept = []
+        @skipped = []
+      end
+
+      def call
+        channel = Hive::InstallMethod.channel
+        remove_binary!(channel)
+        remove_service_unit!
+        Hive::InstallMethod.clear
+        remove_xdg_dirs! if @purge
+
+        if @json
+          puts JSON.generate(
+            "ok" => true,
+            "purge" => @purge,
+            "channel" => channel,
+            "removed" => @removed,
+            "kept" => @kept,
+            "skipped" => @skipped,
+            "note" => "Skills are NOT removed by hive uninstall; remove them via your agent's marketplace."
+          )
+        else
+          print_text_summary
+        end
+        true
+      end
+
+      private
+
+      def remove_binary!(channel)
+        if channel == "brew" || channel == "aur"
+          if channel == "brew"
+            pkg = Hive::InstallMethod.read&.dig("package") || "ivankuznetsov/hive/hive"
+            @skipped << { "type" => "binary", "reason" => "package-managed",
+                          "hint" => "brew uninstall #{pkg}" }
+          else
+            pkg = Hive::InstallMethod.read&.dig("package") || "hive-bin"
+            @skipped << { "type" => "binary", "reason" => "package-managed",
+                          "hint" => "yay -Rns #{pkg}" }
+          end
+          return
+        end
+
+        # One-liner (or unknown) install: remove the XDG-local binary.
+        chosen = Hive::InstallMethod.bin
+        candidates = [ File.join(Hive::Paths.bin_dir, chosen || "hive"),
+                       File.join(Hive::Paths.bin_dir, "hive"),
+                       File.join(Hive::Paths.bin_dir, "hv") ].uniq
+        candidates.select { |p| File.exist?(p) }.each do |p|
+          File.delete(p)
+          @removed << { "type" => "binary", "path" => p }
+        end
+      end
+
+      def remove_service_unit!
+        path = @service.unit_path
+        return unless File.exist?(path)
+
+        # Best-effort stop/disable on Linux; never fatal if systemctl is
+        # absent (container / desktop without systemd-user).
+        unless @service.macos?
+          @runner.call("systemctl --user stop #{@service.unit_name}.service")
+          @runner.call("systemctl --user disable #{@service.unit_name}.service")
+          @runner.call("systemctl --user daemon-reload")
+        end
+        File.delete(path)
+        @removed << { "type" => "service_unit", "path" => path }
+      end
+
+      def remove_xdg_dirs!
+        # Registrations + shared installed assets only; the state dir
+        # (completed-work artifacts, daemon/bot logs that may matter) is
+        # ALWAYS preserved, even under --purge.
+        [ Hive::Paths.config_dir, Hive::Paths.data_dir, Hive::Paths.cache_dir ].each do |dir|
+          next unless File.directory?(dir)
+
+          FileUtils.rm_rf(dir)
+          @removed << { "type" => "dir", "path" => dir }
+        end
+        @kept << { "type" => "dir", "path" => Hive::Paths.state_dir,
+                   "reason" => "preserved even under --purge (work artifacts)" }
+      end
+
+      def print_text_summary
+        if @removed.empty? && @skipped.empty?
+          puts "hive: nothing to uninstall."
+          return
+        end
+        @removed.each { |r| puts "hive: removed #{r['type']}  #{r['path']}" }
+        @skipped.each { |s| puts "hive: #{s['type']} is #{s['reason']} — run: #{s['hint']}" }
+        @kept.each { |k| puts "hive: kept #{k['type']}  #{k['path']} (#{k['reason']})" }
+        puts "hive: uninstalled. Skills are untouched — remove them via your agent's marketplace."
+      end
+    end
+  end
+end
\ No newline at end of file
diff --git a/lib/hive/commands/update.rb b/lib/hive/commands/update.rb
new file mode 100644
index 000000000..9834aceda
--- /dev/null
+++ b/lib/hive/commands/update.rb
@@ -0,0 +1,72 @@
+require "hive"
+require "hive/install_method"
+require "hive/paths"
+
+module Hive
+  module Commands
+    # `hive update` (R14 / U4): shell out to the detected channel's native
+    # updater and never swap the binary in place (which would corrupt a
+    # brew/AUR-managed install). The channel comes from the install-method
+    # marker that the installers write (U6); an absent/unknown marker means
+    # "not installed via a known channel" — refuse with guidance rather than
+    # guess.
+    class Update
+      # Public URL base for release artifacts (the one-liner channel).
+      RELEASE_URL = ENV["HIVE_RELEASE_URL"] ||
+                    "https://github.com/ivankuznetsov/hive/releases/download/v#{Hive::VERSION}"
+
+      def initialize(channel: nil, runner: method(:system), bin: nil)
+        @channel = channel
+        @runner = runner
+        @bin = bin
+      end
+
+      def call
+        resolved = resolve_channel
+        case resolved
+        when "brew"       then run_brew
+        when "aur"        then run_aur
+        when "script"     then run_script
+        else
+          raise Hive::Error,
+                "hive update: hive is not installed via a known channel " \
+                "(no install-method marker at #{Hive::InstallMethod.marker_path}). " \
+                "Install with `brew install ivankuznetsov/hive/hive`, " \
+                "`yay -S hive-bin`, or the one-liner from README, then re-run."
+        end
+      end
+
+      private
+
+      def resolve_channel
+        @channel || Hive::InstallMethod.channel
+      end
+
+      def run_brew
+        package = Hive::InstallMethod.read&.dig("package") || "ivankuznetsov/hive/hive"
+        run("brew upgrade #{package}")
+      end
+
+      def run_aur
+        # The AUR helper the user installed with is recorded in the marker
+        # when available; default to the many-recommended `yay`.
+        package = Hive::InstallMethod.read&.dig("package") || "hive-bin"
+        helper = Hive::InstallMethod.read&.dig("helper") || "yay"
+        run("#{helper} -Syu #{package}")
+      end
+
+      def run_script
+        run("curl -fsSL #{RELEASE_URL}/install.sh | bash")
+      end
+
+      def run(cmd)
+        ok = @runner.call(cmd)
+        return if ok
+
+        raise Hive::UpdaterError,
+              "hive update: the channel updater failed (#{cmd}); " \
+              "run it manually for details"
+      end
+    end
+  end
+end
\ No newline at end of file
